/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER     "0.1"
#define BUFFSZ  4096
#define FXPDATA "~draGon~"
#define PASS    "Password="

#ifndef u_char
    #define u_char  unsigned char
#endif



void foxmail_pwddec(u_char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    u_char  buff[BUFFSZ + 1],
            *ptr,
            *ptr1;


    setbuf(stdout, NULL);

    fputs("\n"
        "Foxmail passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <Account.stg>\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("\nOpening file %s\n\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    if(fseek(fd, 0x800, SEEK_SET) < 0) std_err();

    while(1) {
        if(!fgets(buff, BUFFSZ, fd)) break;
        if(!*buff) break;

        ptr = stristr(buff, PASS);
        if(ptr) {
            ptr += (sizeof(PASS) - 1);
            for(ptr1 = ptr; *ptr1 > 0xd; ptr1++);
            *ptr1 = 0;

            foxmail_pwddec(ptr);
            printf("%s\n", buff);
        }
    }

    fclose(fd);
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void foxmail_pwddec(u_char *pwd) {
    u_char  *enc,
            *ptr;
    int     len,
            old,
            new;

    enc = FXPDATA;
    len = strlen(pwd) >> 1;
    if(!len) return;
    len--;
    sscanf(pwd, "%02X", &old);
    old ^= 0x5a;
    ptr = pwd;
    pwd += 2;
    while(len--) {
        sscanf(pwd, "%02X", &new);
        new ^= *enc++;
        if(old >= new) new--;
        *ptr++ = new - old;
        sscanf(pwd, "%02X", &old);
        pwd += 2;
        if(!*enc) enc = FXPDATA;
    }
    *ptr = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


